{See project source in fparse.lpr for more details on this demo program


ToDo:
-----
    -Make uppercase lowercase invisible tags to the user!
     -*DONE* (use ExecUpCase instead of Exec)
    -
    -
}

unit Unit1; 

{$mode delphi}{$H+}

interface

uses
 sysutils,                          // for Format function
 FastHTMLParser, HTMLUtil,          // Fast Parser Functions
// windows,                           // for GetTickCount function
 classes                            // for stringlist
 ;

type
{..A class just to organize the program better.................................}
    TProg = class
      procedure ProgCreate;
      procedure ProgDestroy;
      procedure Parse1;
      procedure Parse2;

    private
      { Private declarations }
    public
      Tg,Tx : integer;
      Buffer : TStrings;
      procedure OnTag(Tag: string);
      procedure OnText(Text: string);
      procedure OnTag2(Tag: string);
      procedure OnText2(Text: string);

    end;
{..............................................................................}

var
 HrefTag,
 ItalTag,
 BoldTag: boolean;
 Prog1: TProg;

implementation

function GetTickCount: Cardinal;
begin
  Result := Cardinal(Trunc(Now * 24 * 60 * 60 * 1000));
end;


procedure TProg.OnTag(Tag: string);
//show all tags
begin
  Inc(Tg);
  Buffer.Add('TAG: '+Tag);
end;

procedure TProg.OnText(Text: string);
//show all text
begin
  Inc(Tx);
  Buffer.Add('TEXT: '+Text);
end;


procedure TProg.OnTag2(Tag: string);
//trap when we find bold and italics tags
begin
  Inc(Tg);

  if (Tag = '<B>') then  //must be start bold text
   BoldTag:= true;
  if (Tag = '</B>') then //must be end of bold text
   BoldTag:= false;

  if (Tag = '<I>') then  //must be start of italic text
   ItalTag:= true;
  if (Tag = '</I>') then //must be end of italic text
   ItalTag:= false;

end;

{procedure to show all trapped text inside bold and italic tags}
procedure TProg.OnText2(Text: string);

     {local function to replace all carriage returns with #CRLF#, so that our OUTPUT file is on single lines instead of multiple lines.}
     function ConvertCRLF(input: string): string;
     begin
      result:=StringReplace(input,#13#10,'#CRLF#',[rfReplaceAll]); //replace carriage returns with '#CRLF#'
     end;

begin
  Inc(Tx);
  if BoldTag = true then
   Buffer.Add('Bold Text: '+ConvertCRLF(Text));
  if ItalTag = true then
   Buffer.Add('Itallic Text: '+ConvertCRLF(Text));
end;

procedure TProg.Parse1;
var
  Parser : TjsFastHTMLParser; //our fasthtmlparser class
  Tick : Integer;
  Secs : Real;
  Strings : tStrings;
begin
  buffer.clear;            //clear stringlist since it's in the memory all the time
  writeln('Example 1.....');
  if paramstr(1) = '' then //check for first command line argument.. the specified file to parse.
  begin
   writeln('You have to specify a file to parse.');
   writeln;
   exit;
  end;

  if paramstr(1) <> '' then
  begin
    Strings:= tStringList.Create;
    Tg:= 0; Tx:=0;
    Strings.LoadFromFile(paramstr(1));

    Tick:= GetTickCount;
    Parser:= tjsFastHTMLParser.Create(Pchar(Strings.Text));
    Parser.OnFoundTag := OnTag;
    Parser.OnFoundText:= OnText;
    Parser.ExecUpCase;
    Parser.Free;

    Secs:= (getTickCount-Tick)/1000;

    writeln(Format('Total lines: %d lines.',[Strings.Count]));
    writeln(Format('HTML Tag: %d tag.',[tg]));
    writeln(Format('Text: %d text.',[tx]));
    writeln(Format('Required time: %f sec.',[Secs]));
    writeln;

    if (Secs > 0) then
    begin
      writeln(Format('Average line per second: %f line/sec.',[Strings.Count / Secs]));
      writeln(Format('Average byte per second: %f byte/sec.',[Length(Strings.Text) / Secs]));
    end;

    Buffer.SaveToFile('output1.txt');
    writeln('Done parsing all tags in '+paramstr(1)+'. Check ''output1.txt'' for the results.');
    writeln;
    Strings.Free;
  end;
end;

procedure TProg.Parse2;
var
  Parser : TjsFastHTMLParser; //our fasthtmlparser class
  Tick : Integer;
  Secs : Real;
  Strings : tStrings;
begin
  buffer.clear;             //clear stringlist since it's in the memory all the time
  writeln('Example 2.....');
  if paramstr(1) = '' then //check for first command line argument.. the specified file to parse.
  begin
   writeln('You have to specify a file to parse.');
   writeln;
   exit;
  end;
  
  if paramstr(1) <> '' then //if there was a command line argument specified..
  begin
    Strings:= tStringList.Create;
    Tg:= 0; Tx:=0;
    Strings.LoadFromFile(paramstr(1));

    Tick:= GetTickCount;
    Parser:= tjsFastHTMLParser.Create(Pchar(Strings.Text));
    Parser.OnFoundTag:= OnTag2;
    Parser.OnFoundText:= OnText2;
    Parser.ExecUpCase;
    Parser.Free;

    Secs:= (getTickCount-Tick)/1000;

    writeln(Format('Total lines: %d lines.',[Strings.Count]));
    writeln(Format('HTML Tag: %d tag.',[tg]));
    writeln(Format('Text: %d text.',[tx]));
    writeln(Format('Required time: %f sec.',[Secs]));
    writeln;

    if (Secs > 0) then
    begin
      writeln(Format('Average line per second: %f line/sec.',[Strings.Count / Secs]));
      writeln(Format('Average byte per second: %f byte/sec.',[Length(Strings.Text) / Secs]));
    end;

    Buffer.SaveToFile('output2.txt');
    writeln('Done parsing bold tags in '+paramstr(1)+'. Check ''output2.txt'' for the results.');
    writeln;
    Strings.Free;
  end;
end;

procedure TProg.ProgCreate;
begin
{create general stringlist}
  Buffer:= TStringList.Create;
end;

procedure TProg.ProgDestroy;
begin
{clean up general stringlist}
  Buffer.Free; Buffer:= nil;
end;

end.

